<?php

use WHMCS\Database\Capsule;

function XUE_MetaData() {
    return ['DisplayName' => 'XUEIDC 代理插件 3.0'];
}
function XUE_TestConnection($params) {
 if($params['serversecure'] ==true){
$ssl="https://";    
 }else{
 $ssl="http://";
    }                  
    $userstrs = md5($params['serverpassword'] . 'idc.xue.bijieqianxi.cn');
    $url = "http://". $params['serverhostname'] . "/api/cloudapi.asp?action=activate&userid=" . $params['serverusername'] . "&userstrs=" . $userstrs;
    $data = file_get_contents($url);
    if ($data == '请先选择购买时间') {
        return ['success' => true];
    } else {
        return ['error' => '账号或KEY错误'];
    }
}
function XUE_ConfigOptions() {
    return [
    '产品ID' => ['Type' => 'text', 'Description' => '产品ID<br>请在代理站查看产品 ID'],
    '无需填写' => ['Type' => 'text', 'Description' => '无需填写'],  
    "对接的产品分类" => ["Type" => "dropdown","Options" => "虚拟主机,VPS,CDN",],
	'控制面板地址' => ['Type' => 'text', 'Description' => '控制面板地址<br>请在代理站查看控制面板地址'],
	'月付时间' => ['Type' => 'text', 'Description' => '<br>请填写1'],
    '季付时间' => ['Type' => 'text', 'Description' => '<br>请填写3'],
    '半年付时间' => ['Type' => 'text', 'Description' => '<br>请填写6'],
    '年付时间' => ['Type' => 'text', 'Description' => '<br>请填写1y'],
];
}

function XUE_buyyearjs($params){
    $billingcycle = $params['model']['attributes']['billingcycle'];
	if(!$billingcycle){
		return false;
	}
	switch ($billingcycle){
	//月付
	case 'Monthly':
	  if(!@$params['configoption5']){
		  $hostingcycle = '1';
	  }else{
		  $hostingcycle = trim($params['configoption5']);
	  }
 	  break;
	 //季付
	case 'Quarterly':
	  if(!@$params['configoption6']){
		  $hostingcycle = '3';
	  }else{
		  $hostingcycle = trim($params['configoption6']);
	  }
 	  break;
	//半年付
	case 'Semi-Annually':
	  if(!@$params['configoption7']){
		  $hostingcycle = '6';
	  }else{
		  $hostingcycle = trim($params['configoption7']);
	  }
 	  break;
	//年付
	case 'Annually':
	  if(!@$params['configoption8']){
		  $hostingcycle = '1y';
	  }else{
		  $hostingcycle = trim($params['configoption8']);
	  }
 	  break;
	default:
	  return false;
	}
    return $hostingcycle;
}
function XUE_CreateAccount($params) {
$BuyYear = XUE_buyyearjs($params);
if(!$BuyYear){
return '续费年限计算失败';
}
 if($params['serversecure'] ==true){
$ssl="https://";    
 }else{
 $ssl="http://";
    } 
if ($params['configoption3'] == "VPS"){
    $userstrs = md5($params['serverpassword'] . 'idc.xue.bijieqianxi.cn');
    $url = $ssl . $params['serverhostname'] . '/api/cloudapi.asp?action=activate&vpsname=' . $params["username"] . '&VPSpassword=' . $params["password"] . '&userid=' . $params['serverusername'] . '&userstrs=' . $userstrs . '&productid=' . $params['configoption1'] . '&year='.$BuyYear;
    $data = file_get_contents($url);
    parse_str($data, $database);
    if ($database['ret'] == 'ok') {
        updateService(array(
            'domain' => $database['vpsname'],
            'username' => $database['vpsname'],
            'password' => $database['vpspassword']
        ));
        return 'success';
    } else if($data==""){
        return "返回为空，代理平台配置问题，请联系代理平台管理员";
    }else{
        return $data;
}
}
if ($params['configoption3'] == "虚拟主机"){
    $a = 'add_vh';
    $r = rand(1000,9999);
    $s = md5($a . $params['serverpassword'] . $r . 'idc.xue.bijieqianxi.cn');
    $url = $ssl . $params['serverhostname'] . '/api/host/' . '?a=' . $a . '&r=' . $r . '&s=' . $s . '&b=whm&init=1&name=' . $params["username"] . '&passwd=' . $params["password"] .  '&user=' . $params['serverusername'] . '&product_id=' . $params['configoption1'] . '&buytime='.$BuyYear;
    $data = file_get_contents($url);
    if ($data == 'True') {
    return 'success';       
  } else if($data==""){
        return "返回为空，代理平台配置问题，请联系代理平台管理员";
    }else{
        return $data;
    }
  }
if ($params['configoption3'] == "CDN"){
$a = 'add_vh';
    $r = rand(1000,9999);
    $s = md5($a . $params['serverpassword'] . $r . 'idc.xue.bijieqianxi.cn');
    $url = $ssl . $params['serverhostname'] . '/api/cdn/' . '?a=' . $a . '&r=' . $r . '&s=' . $s . '&b=whm&init=1&name=' . $params["username"] . '&passwd=' . $params["password"] .  '&user=' . $params['serverusername'] . '&product_id=' . $params['configoption1'] . '&buytime='.$BuyYear;
    $data = file_get_contents($url);
    if ($data == 'True') {
    return 'success';       
  } else if($data==""){
        return "返回为空，代理平台配置问题，请联系代理平台管理员";
    }else{
        return $data;
    }
}
}
function XUE_Renew($params) {
	$BuyYear = XUE_buyyearjs($params);
	if(!$BuyYear){
		return '续费年限计算失败';
	}
if ($params['configoption3'] == "VPS"){
    $userstrs = md5($params['serverpassword'] . 'idc.xue.bijieqianxi.cn');
    $url = 'http://' . $params['serverhostname'] . '/api/cloudapi.asp?action=renew&vpsname=' . $params["username"] . '&userid=' . $params['serverusername'] . '&userstrs=' . $userstrs . '&year='.$BuyYear;
    $data = file_get_contents($url);
    parse_str($data, $database);
    if ($database['ret'] == 'ok') {
        return 'success';
    } else {
        return $data;
    }
}
if ($params['configoption3'] == "虚拟主机"){
    $a = 'xfhost';
    $r = rand(1000,9999);
    $s = md5($a . $params['serverpassword'] . $r . 'idc.xue.bijieqianxi.cn');
    $url = 'http://' . $params['serverhostname'] . '/api/host/' . '?a=' . $a . '&r=' . $r . '&s=' . $s . '&b=whm&edit=1&name=' . $params["username"] .  '&user=' . $params['serverusername'] . '&buytime='.$BuyYear;
    $data = file_get_contents($url);
    if ($data == 'True') {
    return 'success';       
  }else{
  return '代理账号或KEY错误';  
  }
}
if ($params['configoption3'] == "CDN"){
$a = 'xfhost';
    $r = rand(1000,9999);
    $s = md5($a . $params['serverpassword'] . $r . 'idc.xue.bijieqianxi.cn');
    $url = 'http://' . $params['serverhostname'] . '/api/cdn/' . '?a=$a' . '&r=$r' . '&s=$s' . '&b=whm&edit=1&name=' . $params["username"] .  '&user=' . $params['serverusername'] . '&buytime='.$BuyYear;
    $data = file_get_contents($url);
    if ($data == 'True') {
    return 'success';       
  }else{
  return '代理账号或KEY错误';  
  }
}

return 'success';
}

function XUE_ClientArea($params) {
    return array(
     'tabOverviewReplacementTemplate' => 'overview.tpl',        
        'templateVariables' => array(
            'bomi' => $params,
        ) ,
    );
}
function XUE_SuspendAccount($params) {
    return 'success';
}
function XUE_TerminateAccount($params) {
    return 'success';
}
function XUE_ResetPassword($params) {
    return '不支持修改密码';
}
function XUE_ChangePackage($params) {
    return '不支持修改密码';
}
?>
